# vega-transforms

Data processing transforms for Vega dataflows.

This module provides the following Vega data transforms:

- [**Aggregate**](https://vega.github.io/vega/docs/transforms/aggregate/) [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Aggregate.js "Source")
- [**Bin**](https://vega.github.io/vega/docs/transforms/bin/) [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Bin.js "Source")
- [**Collect**](https://vega.github.io/vega/docs/transforms/collect/) [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Collect.js "Source")
- [**CountPattern**](https://vega.github.io/vega/docs/transforms/countpattern/) [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/CountPattern.js "Source")
- [**Cross**](https://vega.github.io/vega/docs/transforms/cross/) [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Cross.js "Source")
- [**Density**](https://vega.github.io/vega/docs/transforms/density/) [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Density.js "Source")
- [**Extent**](https://vega.github.io/vega/docs/transforms/extent/) [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Extent.js "Source")
- [**Filter**](https://vega.github.io/vega/docs/transforms/filter/) [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Filter.js "Source")
- [**Flatten**](https://vega.github.io/vega/docs/transforms/flatten/) [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Flatten.js "Source")
- [**Fold**](https://vega.github.io/vega/docs/transforms/fold/) [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Fold.js "Source")
- [**Formula**](https://vega.github.io/vega/docs/transforms/formula/) [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Formula.js "Source")
- [**Impute**](https://vega.github.io/vega/docs/transforms/Impute/) [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/impute.js "Source")
- [**JoinAggregate**](https://vega.github.io/vega/docs/transforms/joinaggregate/) [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/JoinAggregate.js "Source")
- [**Lookup**](https://vega.github.io/vega/docs/transforms/lookup/) [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Lookup.js "Source")
- [**Pivot**](https://vega.github.io/vega/docs/transforms/pivot/) [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Pivot.js "Source")
- [**Project**](https://vega.github.io/vega/docs/transforms/project/) [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Project.js "Source")
- [**Sample**](https://vega.github.io/vega/docs/transforms/sample/) [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Sample.js "Source")
- [**Sequence**](https://vega.github.io/vega/docs/transforms/sequence/) [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Sequence.js "Source")
- [**Window**](https://vega.github.io/vega/docs/transforms/window/) [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Window.js "Source")

And also provides the following internal transforms:

- **Compare** [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Compare.js "Source")
- **Facet** [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Facet.js "Source")
- **Field** [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Field.js "Source")
- **Generate** [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Generate.js "Source")
- **Key** [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Key.js "Source")
- **MultiExtent** [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/MultiExtent.js "Source")
- **MultiValues** [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/MultiValues.js "Source")
- **Params** [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Params.js "Source")
- **PreFacet** [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/PreFacet.js "Source")
- **Proxy** [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Proxy.js "Source")
- **Relay** [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Relay.js "Source")
- **Sieve** [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Sieve.js "Source")
- **Subflow** [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Subflow.js "Source")
- **TupleIndex** [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/TupleIndex.js "Source")
- **Values** [&lt;&gt;](https://github.com/vega/vega-transforms/blob/master/src/Values.js "Source")

For more information about data stream transforms, see the
[Vega transform documentation](https://vega.github.io/vega/docs/transforms/).
