/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

import Color from 'color';

export default (color, fill = 1) => {
  const initialColor = new Color(color).rgb();

  const opacity = Math.min(Number(fill), 1) * initialColor.valpha;
  const [r, g, b] = initialColor.color;

  return {
    fill: opacity > 0,
    fillColor: new Color([
      r, g, b, Number(opacity.toFixed(2)),
    ]).string(),
  };
};
